#include "sfr_r813.h";

#include "r8c_routinen.h";

void CLK_20MHz (void)
{   
    /*-------------------------------------------------
    -  Change on-chip oscillator clock to Main clock  -
    -------------------------------------------------*/

    prc0 = 1;           	/* Protect off */
    cm13 = 1;           	/* Xin Xout */
    cm15 = 1;           	/* XCIN-XCOUT drive capacity select bit : HIGH */
    cm05 = 0;           	/* Xin on */
    cm16 = 0;           	/* Main clock = No division mode */
    cm17 = 0;
    cm06 = 0;           	/* CM16 and CM17 enable */
    asm("nop");         	/* Waiting for stable of oscillation */
    asm("nop");
    asm("nop");
    asm("nop");
    ocd2 = 0;           	/* Main clock change */
    prc0 = 0;           	/* Protect on */
}

void uart0init(void)
{
	u0c1 = u0c1 | 0x05;		//Initialisierung des UART0
	u0mr = 0x01;
	u0c0 = 0x80;
	u0brg = 2;				//Zum aendern, je nach gewollte geschwingikeit 
	//u0brg =100;
	drr = 0xff;
}
void ioinit(void)
{
	//hier mit serieller Schnittstelle realisiert
	//Beispielprojekte im Buch:
	//- Display (andon) mit serieller Schnittstelle
	//- GPS-Display mit GPIO
	/*
	Pinbelegung Display		Pin an R8C Modul	
	1	VCC (3,3V)
	2	SCLK				9 (P1_6; UART0 im seriellen Mode->serial Clock)
	3	SDIN				11(P1_4; TXD0)
	4	D/XC				14(P1_1)
	5	XCS					13(P1_2)
	6	M
	7	10uF 10V gegen M	
	8 	XRES				17(P3_3)
	*/

	//Datenrichtung der Ports einstellen (1=Ausgang; 0=Eingang) nach Reset sind alle Ports Eingnge
	//pd0 = 0b01111110;		
	pd1 = 0b11111111;
	pd3 = 0b00001100;
	//pd4_5 = 0;
	
	//interne 90uA (...kOhm Pulls bei xV)
	//Register PUR0 und PUR1
	//einzelne Bits z.B. mit pu03 fr pur0.3
	//pu12 = 1;
	
	//Treiberstrke bei Port 1 auf auf 30mA sink Strom einstellbar
	//Register drr
	//einzelne Bits mit drr0 fr drr.0	
}
unsigned char SPI_SendByte(unsigned char data)
{
	while(ti_u0c1 == 0);	//sicherstellen das Schnittstelle nicht benutzt wird
	u0tb = data;
	while(ri_u0c1 == 0);	//warten bis Transmission fertig ist
	data = u0rb;			
	return data;
}
void wait_ms(long y)
{   
	long z;
	y = y * 520;                        // Wert fr ms Zhlschleife bei 20MHz
	for( z=0; z<y; z++ );
}